//
// Implementazione della Classe List: doppi puntatori con "sentinella"
//


#include <iostream.h>
#include "List1.H"


// Costruttore per il tipo di dato Lista.
List::List()
{
  sentinel = new node;		// Creo il nodo sentinella
  sentinel->next = sentinel->prev = sentinel;	// Inizializzo la sentinella

  current = sentinel;
}

// Distruttore per il tipo di dato Lista
List::~List()
{
  GoToFirst();			// Vai al primo elemento della Lista

  while (!IsEndOfList())	// Finche non sono arrivato alla sentinella
    Delete();			// Cancella un elemento

  delete sentinel;		// Elimina infine anche la sentinella
}


// Restituisce l'elemento della Lista nella posizione corrente.
mytype List::Read() const
{
  if (IsEndOfList()) {
    cerr << "Errore: non e` possibile accedere alla sentinella!" << endl;
    exit(-2);
  }

  return(current->data);
}



// Spostiamo il nodo corrente sul nodo successivo
void List::Next()
{
  if (IsEndOfList()) {		// Errore se siamo alla fine della Lista
    cerr << "Errore: Next, non possiamo scavalcare la sentinella!"
	 << endl;
    exit(-2);
  }
  else
    current = current->next;
}


// Spostiamo il nodo corrente sul nodo precedente
void List::Previous()
{
  if (IsFirst()) {		// Non si puo` andare oltre il primo elemento
    cerr << "Errore: Previous, non possiamo andare sulla sentinella!"
	 << endl;
    exit(-2);
  }
  else
    current = current->prev;
}


// Inserimento nella Posizione corrente
void List::Insert(const mytype &d)
{
  node *newel = new node;	// Costruiamo un nuovo nodo

  newel->data = d;		// Inizializzo il valore del nodo
  newel->prev = current->prev;	// Il nuovo nodo e` inserito PRIMA del nodo
  newel->next = current;	// corrente

  current->prev = newel;
  newel->prev->next = newel;

  len++;
}


// Cancella l'elemento nella posizione corrente
mytype List::Delete()
{
  mytype tmp;

  if (IsEndOfList()) { 
    cerr << "Errore: Delete, non e` possibile cancellare la sentinella!"
	 << endl;
    exit(-2);
  }

  node *tmpp = current->next;
  tmp = current->data;

  current->next->prev = current->prev;
  current->prev->next = current->next;

  delete current;

  len--;

  current = tmpp;

  return(tmp);
}


// Cambia il campo informazione del nodo corrente
void List::Write(const mytype &d)
{
  if (IsEndOfList()) {
    cerr << "Errore: Wite non e` possibile scrivere sulla sentinella!" << endl;
    exit(-2);
  }

  current->data = d;
}









