//
// Classe per rappresentare una Lista. Doppi puntatori con "sentinella"
//



#ifndef LIST_HDR
#define LIST_HDR

typedef int mytype;			// Il tipo dei nostri dati


class node {
  friend class List;		// List puo` accedere alla parte privata

  node *prev;			// Puntatore all'elemento precedente
  node *next;			// Puntatore all'elemento successivo
  mytype data;			// L'elemento memorizzato nel nodo
};



class List {
  node *sentinel;		// Puntatore alla Sentinella
  node *current;		// Puntatore all'elemento corrente
  int len;			// La lunghezza della Lista

public:
  List();			// Costruttore
  ~List();			// Distruttore

  void Next();			// Sposta in avanti
  void Previous();		// Sposta indietro

  void GoToFirst()		// Posiziona sul primo elemento della Lista
    {  current = sentinel->next; }
  void GoToEndOfList()		// Posiziona sull'ultimo elemento della Lista
    {  current = sentinel; }

  int IsEmpty()	const		// La Lista e` vuota?
    { return(sentinel->next == sentinel); }
  int IsEndOfList() const	// Sono sulla sentinella?
    { return(current == sentinel); }
  int IsFirst() const		// Sono sul primo elemento?
    { return(current == sentinel->next); }

  void Write(const mytype &d);	// Scrive un nuovo dato nell'elemento corrente
  mytype Read() const;		// Restituisce l'elemento nella posizione
				// corrente della Lista

  void Insert(const mytype &d);	// Aggiunge un elemento nella Lista
  mytype Delete();		// Rimuove l'elemento corrente dalla Lisat (e
				// lo restituisce)
};
#endif
